const express = require("express");
const router = express.Router();
const mailingController = require("../controllers/mailingController");



// Public routes (removed auth requirements)
router.get("/", mailingController.getHomePage);
router.get(
  "/settings",
  mailingController.getSettingsPage,
);
router.post(
  "/send-email",
  mailingController.sendEmail,
);

// Settings API routes
router.get(
  "/api/settings",
  mailingController.getSettings
);
router.post(
  "/api/settings",
  mailingController.saveSettings
);
router.post(
  "/api/test-connection",
  mailingController.testConnection
);





module.exports = router;
